#include "stdafx.h"
#include "War3TypesAndConstants.h"
#include "Unit.h"
#include "UnitsList.h"

//********************************************************************************
CUnitsList::CListedUnit::CListedUnit()
{
	next = NULL;
}

CUnitsList::CListedUnit::~CListedUnit()
{

}
//********************************************************************************

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CUnitsList::CUnitsList()
{
	m_pHead = NULL;
	m_pCurrent = NULL;
	m_iNbUnits = 0;
}

CUnitsList::~CUnitsList()
{
	ClearList();
}

void CUnitsList::ClearList()
{
	CListedUnit *pLUnit;
	m_pCurrent = NULL;
	// clear unit list
	while(m_pHead)
	{
		pLUnit = m_pHead;
		m_pHead = m_pHead->next;
		delete pLUnit;
	}
	m_iNbUnits = 0;
}

void CUnitsList::AddUnit(CUnit unit)
{
	CListedUnit *pLUnit;
	pLUnit = new CListedUnit;
	pLUnit->next = m_pHead;
	pLUnit->unit = unit;
	m_pHead = pLUnit;
	m_iNbUnits++;
}

void CUnitsList::GoFirstUnit()
{
	m_pCurrent = m_pHead;
}

CUnit CUnitsList::GetNext()
{
	CUnit unit;
	if	(m_pCurrent)
	{
		unit = m_pCurrent->unit;
		m_pCurrent = m_pCurrent->next;
	}
	else
	{
		m_pCurrent = m_pHead;
		unit.type = "";
	}
	return unit;
}

int CUnitsList::GetNbUnits()
{
	return m_iNbUnits;
}
